%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXC:COMPILER.SL
% Description:  PSL Compiler.
% Author:       Harold Carr & Leigh Stoller
% Created:
% Modified:
% Mode:         Lisp
% Package:
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1987, University of Utah, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%
% This file loads in all the compiler modules for alpha.
%

(load datamachine pass-1 pass-2-3 comp-decls pass-1-lap alpha-lap
      alpha-cmac alpha-comp registers alpha-instrs lapopt faslout
      alpha-spec big-faslend)

(setq *writingfaslfile nil)
(setq *writingasmfile nil)

(de putbittable (baseaddress bitoffset value2)
  (prog (m b c)
        (setq b
              (iland (byte baseaddress (setq m (ilsh bitoffset -2)))
                     (ilsh (idifference -1 (itimes2 3 256))
                      (idifference -2
                       (setq c (itimes2 (field bitoffset 62 2) 2))))))
        (putbyte baseaddress m (if (eq value2 0)
                   b
                   (ilor b (ilsh value2 (idifference 6 c)))))))

(de makerelocword (reloctag relocinf)
  (wplus2 (wshift reloctag 62) (field relocinf 2 62)))

(de makerelocinf (reloctag relocinf)
  (wplus2 (wshift reloctag 54) (field relocinf 10 54)))


(remprop 'bittable 'opencode)
(remprop 'putbittable 'opencode)
(remprop 'wquotient 'openfn)
% End of file.
