 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %
 % File:           PVC:COMP-DECLS.SL
 % Description:    Not quite Machine-independent compiler declarations
 % Author:         Eric Benson, Sam Sands
 % Created:        16-October-1981
 % Modified:       28 Mar 1984 1510-PST (Nancy Kendzierski)
 % Mode:           Lisp
 % Package:
 % Status:         Experimental (Do Not Distribute)
 %
 % (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
 % (c) Copyright 1987, Konrad Zuse Zentrum Berlin for modifications.
 %
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %
 % Revisions:
 %
 % 11 Mar 86 H. Melenk (ZIB)
 %     Update for PSL 3.4 (Cray)
 % 5 May 1984 (Brian Beach)
 %    Removed machine independent parts into PASS-1-DECLS.SL.
 % 28 Mar 1984 1509-PST (Nancy Kendzierski)
 %    Fixed file name in header.  Merged in two previous changes.
 % 28-Mar-84 13:45:59 (Jim Ambras/CRC)
 %    Added two puts related to the function EQ to catch an unfolded constant.
 % 27-Mar-84 08:23:48 (Brian Beach)
 %    Added COMPFNs for IDAPPLY and CODEAPPLY.
 %    Added argument count properties for COMPFNs.
 % 12-Jan-84            (Sam Sands)
 %     Removed M68000 specific stuff for benefit of VAX et. al.
 % 15-Dec-83 10:59:59 (Tim Tillson)
 %    Added Brian Beech's pass1 functions for WARRAYS, WVARS and WSTRINGS to
 %    Sam's D-register model version
 %
 %    <PSL.COMP>COMP-DECLS.RED.16,  3-Sep-82 09:46:43, Edit by BENSON
 %    Added PA1REFORMFN for WNOT
 %    <PSL.COMP>COMP-DECLS.RED.5,   3-Dec-82 18:20:08, Edit by PERDUE
 %    Removed PA1REFORMFN for NE
 %    <PSL.COMP>COMP-DECLS.RED.6,  24-Jan-83 16:04:00, Edit by MLGriss
 %    Changed W to %%%W in the EQCAR to avoid subst W into EQCAR form
 %
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 (put '*JUMPNOTEQ      'negjmp '*JUMPEQ)
 (put '*JUMPWLESSP     'negjmp '*JUMPWGEQ)
 (put '*JUMPWGEQ       'negjmp '*JUMPWLESSP)
 (put '*JUMPWLEQ       'negjmp '*JUMPWGREATERP)
 (put '*JUMPWGREATERP  'negjmp '*JUMPWLEQ)
 
 (put '*jumptype       'negjmp '*jumpnottype)
 (put '*jumpnottype    'negjmp '*jumptype)
 (put '*jumpintype     'negjmp '*jumpnotintype)
 (put '*jumpnotintype  'negjmp '*jumpintype)
 
 (put 'AND        'opentst         '&TSTANDOR)
 (put 'OR         'opentst         '&TSTANDOR)
 
 (put 'EQ         'opentst         '(TSTPAT  *JUMPEQ        ))
 (put 'NE         'opentst         '(TSTPAT  *JUMPNOTEQ     ))
 
 (put 'wgreaterp  'opentst         '(tstpatc *jumpwgreaterp *jumpwlessp))
 (put 'wleq       'opentst         '(tstpatc *jumpwleq      *jumpwgeq))
 (put 'wgeq       'opentst         '(tstpatc *jumpwgeq      *jumpwleq))
 (put 'wlessp     'opentst         '(tstpatc *jumpwlessp    *jumpwgreaterp))
 
 (put 'PAIRP      'opentst         '(tstpat2 *jumptype     PAIR-TAG))
 (put 'ATOM       'opentst         '(tstpat2 *jumpnottype PAIR-TAG))
 (put 'STRINGP    'opentst         '(tstpat2 *jumptype     STRING-TAG))
 (put 'NOTSTRINGP 'opentst         '(tstpat2 *jumpnottype STRING-TAG))
 (put 'VECTORP    'opentst         '(tstpat2 *jumptype     VECTOR-TAG))
 (put 'NOTVECTORP 'opentst         '(tstpat2 *jumpnottype VECTOR-TAG))
 (put 'EVECTORP   'opentst         '(tstpat2 *jumptype     EVECTOR-TAG))
 (put 'NOTEVECTORP 'opentst        '(tstpat2 *jumpnottype EVECTOR-TAG))
 (put 'CODEP      'opentst         '(tstpat2 *jumptype     CODE-TAG))
 (put 'NOTCODEP   'opentst         '(tstpat2 *jumpnottype CODE-TAG))
 (put 'FLOATP     'opentst         '(tstpat2 *jumptype     FLOATNUM-TAG))
 (put 'NOTFLOATP  'opentst         '(tstpat2 *jumpnottype FLOATNUM-TAG))
 
%(put 'INTP       'opentst         '(tstpat2 *jumpintype   POSINT-TAG))
 (put 'NOTINTP    'opentst         '(tstpat2 *jumpnotintype POSINT-TAG))
 (put 'FIXP       'opentst         '(tstpat2 *jumpintype   BIGNUM-TAG))
 (put 'NOTFIXP    'opentst         '(tstpat2 *jumpnotintype BIGNUM-TAG))
 (put 'NUMBERP    'opentst         '(tstpat2 *jumpintype   FLOATNUM-TAG))
 (put 'NOTNUMBERP 'opentst         '(tstpat2 *jumpnotintype FLOATNUM-TAG))
 
 (put 'FIXNP      'opentst         '(tstpat2 *jumptype     FIXNUM-TAG))
 (put 'NOTFIXNP   'opentst         '(tstpat2 *jumpnottype FIXNUM-TAG))
 (put 'BIGP       'opentst         '(tstpat2 *jumptype     BIGNUM-TAG))
 (put 'NOTBIGP    'opentst         '(tstpat2 *jumpnottype BIGNUM-TAG))
 (put 'POSINTP    'opentst         '(tstpat2 *jumptype     POSINT-TAG))
 (put 'NOTPOSINTP 'opentst         '(tstpat2 *jumpnottype POSINT-TAG))
 (put 'NEGINTP    'opentst         '(tstpat2 *jumptype     NEGINT-TAG))
 (put 'NOTNEGINTP 'opentst         '(tstpat2 *jumpnottype NEGINT-TAG))
 (put 'IDP        'opentst         '(tstpat2 *jumptype     ID-TAG))
 (put 'NOTIDP     'opentst         '(tstpat2 *jumpnottype ID-TAG))
 (put 'BYTESP     'opentst         '(tstpat2 *jumptype     BYTES-TAG))
 (put 'NOTBYTESP  'opentst         '(tstpat2 *jumpnottype BYTES-TAG))
 (put 'WRDSP      'opentst         '(tstpat2 *jumptype     WORDS-TAG))
 (put 'NOTWRDSP   'opentst         '(tstpat2 *jumpnottype WORDS-TAG))
 (put 'HALFWORDSP 'opentst         '(tstpat2 *jumptype     HALFWORDS-TAG))
 (put 'NOTHALFWORDSP 'opentst      '(tstpat2 *jumpnottype HALFWORDS-TAG))
 
 
 (put 'EQ          'openfn      '(TVPAT *JUMPEQ        ))
 (put 'NE          'openfn      '(TVPAT *JUMPNOTEQ     ))
 (put 'WGREATERP   'openfn      '(TVPAT *JUMPWGREATERP))
 (put 'WLEQ        'openfn      '(TVPAT *JUMPWLEQ      ))
 (put 'WGEQ        'openfn      '(TVPAT *JUMPWGEQ      ))
 (put 'WLESSP      'openfn      '(TVPAT *JUMPWLESSP    ))
 
 (put 'PAIRP       'openfn      '(tvpat1 *jumptype     PAIR-TAG))
 (put 'ATOM        'openfn      '(tvpat1 *jumpnottype PAIR-TAG))
 (put 'STRINGP     'openfn      '(tvpat1 *jumptype     STRING-TAG))
 (put 'NOTSTRINGP  'openfn      '(tvpat1 *jumpnottype STRING-TAG))
 (put 'VECTORP     'openfn      '(tvpat1 *jumptype     VECTOR-TAG))
 (put 'NOTVECTORP  'openfn      '(tvpat1 *jumpnottype VECTOR-TAG))
 (put 'EVECTORP    'openfn      '(tvpat1 *jumptype     EVECTOR-TAG))
 (put 'NOTEVECTORP 'openfn      '(tvpat1 *jumpnottype EVECTOR-TAG))
 (put 'CODEP       'openfn      '(tvpat1 *jumptype     CODE-TAG))
 (put 'NOTCODEP    'openfn      '(tvpat1 *jumpnottype CODE-TAG))
 (put 'FLOATP      'openfn      '(tvpat1 *jumptype     FLOATNUM-TAG))
 (put 'NOTFLOATP   'openfn      '(tvpat1 *jumpnottype FLOATNUM-TAG))
 
%(put 'INTP        'openfn      '(tvpat1 *jumpintype   POSINT-TAG))
 (put 'NOTINTP     'openfn      '(tvpat1 *jumpnotintype POSINT-TAG))
 (put 'FIXP        'openfn      '(tvpat1 *jumpintype   BIGNUM-TAG))
 (put 'NOTFIXP     'openfn      '(tvpat1 *jumpnotintype BIGNUM-TAG))
 (put 'NUMBERP     'openfn      '(tvpat1 *jumpintype   FLOATNUM-TAG))
 (put 'NOTNUMBERP  'openfn      '(tvpat1 *jumpnotintype FLOATNUM-TAG))
 
 (put 'FIXNP         'openfn     '(tvpat1 *jumptype     FIXNUM-TAG))
 (put 'NOTFIXNP      'openfn     '(tvpat1 *jumpnottype FIXNUM-TAG))
 (put 'BIGP          'openfn     '(tvpat1 *jumptype     BIGNUM-TAG))
 (put 'NOTBIGP       'openfn     '(tvpat1 *jumpnottype BIGNUM-TAG))
 (put 'POSINTP       'openfn     '(tvpat1 *jumptype     POSINT-TAG))
 (put 'NOTPOSINTP    'openfn     '(tvpat1 *jumpnottype POSINT-TAG))
 (put 'NEGINTP       'openfn     '(tvpat1 *jumptype     NEGINT-TAG))
 (put 'NOTNEGINTP    'openfn     '(tvpat1 *jumpnottype NEGINT-TAG))
 (put 'IDP           'openfn     '(tvpat1 *jumptype     ID-TAG))
 (put 'NOTIDP        'openfn     '(tvpat1 *jumpnottype ID-TAG))
 (put 'BYTESP        'openfn     '(tvpat1 *jumptype     BYTES-TAG))
 (put 'NOTBYTESP     'openfn     '(tvpat1 *jumpnottype BYTES-TAG))
 (put 'WRDSP         'openfn     '(tvpat1 *jumptype     WORDS-TAG))
 (put 'NOTWRDSP      'openfn     '(tvpat1 *jumpnottype WORDS-TAG))
 (put 'HALFWORDSP    'openfn     '(tvpat1 *jumptype     HALFWORDS-TAG))
 (put 'NOTHALFWORDSP 'openfn     '(tvpat1 *jumpnottype HALFWORDS-TAG))
 
 (put 'wplus2        'openfn     '(assocpat    *wplus2))
 (put 'wquotient     'openfn     '(nonassocpat *Wquotient))
 (put 'wdifference   'openfn     '(subpat *wdifference))
 (put 'wtimes2       'openfn     '(assocpat *wtimes2))
 (put 'wminus        'openfn     '(unarypat *wminus))
 (put 'wand          'openfn     '(assocpat *wand))
 (put 'wor           'openfn     '(assocpat *wor))
 (put 'wxor          'openfn     '(assocpat *wxor))
 (put 'wnot          'openfn     '(unarypat *wnot))
 (put 'wshift        'openfn     '(nonassocpat *wshift))
 (put 'ashift        'openfn     '(nonassocpat *ASHIFT))       %  scs
 (put 'mkitemrev     'openfn     '(nonassocpat *mkitem))
 (put 'loc           'openfn     '(unarypat *loc))
 (put 'field         'openfn     '(fieldpat *field))
 (put 'signedfield   'openfn     '(fieldpat *signedfield))
 (put 'putfieldrev   'openfn     '(putfieldpat *putfield))
 (put 'Wldzero       'openfn     '(unarypat *wldzero))
 (put 'Wpopcnt       'openfn     '(unarypat *wpopcnt))
 (put 'Wpopcntp      'openfn     '(unarypat *wpopcntp))
 
 (put '$NAME         'openfn     '$NAME)      % DUMMY     %   scs
 (put 'CAR           'openfn     '(carcdrpat car))        %   scs
 (put 'CDR           'openfn     '(carcdrpat cdr))        %   scs
 (put 'MEMORY        'openfn     '(memorypat memory))     %   scs
 (put 'aplus2        'openfn     '(aplus2pat $aplus2))
 (put 'atimes2       'openfn     '(atimes2pat $atimes2))
 
 (put 'SETQ          'openfn     '(setqpat NIL))
 (put 'RPLACA        'openfn     '(rplacpat car))
 (put 'RPLACD        'openfn     '(rplacpat cdr))
 
 (put 'wlshift       'openfn     '(nonassocpat *wlshift))
 (put 'wrshift       'openfn     '(nonassocpat *wrshift))
 
 (put 'cons          'openfn     '(conspat *cons))  %open cons !!
 
 (put 'fastmkfltn    'openfn     '(fastmkfltnpat *fastmkfltn))
 
 (put '!%!%reclaim   'openfn     '(reclaimpat *reclaim))
 
 % In memory operations
 
%(put '*addmem   'openfn           '(modmempat *addmem *wplus2 ))
%(put '*mpymem   'openfn           '(modmempat *mpymem *wtimes2))
 
%(flag '(*ADDMEM *MPYMEM)       'MEMMOD)
 
%(put 'WPLUS2       'MEMMODFN    '*ADDMEM)
%(put 'WTIMES2      'MEMMODFN    '*MPYMEM)
 
%(put '*ADDMEM  'UNMEMMOD     '*WPLUS2)
%(put '*MPYMEM  'UNMEMMOD     '*WTIMES2)
 
 
 % Match functions
 
 (put 'ANY       'matchfn '&ANY)
 (put 'VAR       'matchfn '&VAR)
 (put 'REG       'matchfn '&REGFP)
 (put 'DEST      'matchfn '&DEST)
 (put 'USESDEST  'matchfn '&USESDEST)
 (put 'REGN      'matchfn '&REGN)
 (put 'NOTDEST   'matchfn '&NOTDEST)
 (put 'NOTANYREG 'matchfn '&NOTANYREG)
 (put 'MEM       'matchfn '&MEM)
 (put 'MEMORY    'matchfn '&MEMORY)
 (put 'ANYREGFN  'matchfn '&ANYREGFNP)
 
 (put 'REGNP     'matchfn    '&REGNP)                           %     scs
 (put 'CONST     'matchfn    '&CONSTP)                          %     scs
 
 
 % Macro functions
 
 (put 'A1  'substfn '&ARG1)
 (put 'A2  'substfn '&ARG2)
 (put 'A3  'substfn '&ARG3)
 (put 'A4  'substfn '&ARG4)
 (put 'FN  'substfn '&PARAM1)
 (put 'MAC 'substfn '&PARAM2)
 (put 'P2  'substfn '&PARAM3)
 (put 'P3  'substfn '&PARAM4)
 (put 'T1  'substfn '&GETTEMP)
 (put 'T2  'substfn '&GETTEMP)
 (put 'T3  'substfn '&GETTEMP)
 (put 'T4  'substfn '&GETTEMP)
 (put 'L1  'substfn '&GETTEMPLBL)
 (put 'L2  'substfn '&GETTEMPLBL)
 (put 'L3  'substfn '&GETTEMPLBL)
 (put 'L4  'substfn '&GETTEMPLBL)
 (put 'LA1 'substfn '&LOCARG1)                                             % scs
 
 (de &LOCARG1 (tname args params) (&locate (&arg1 tname args params))   )  % scs
 
 % Emit functions
 
 (put '*LOAD    'emitfn '&EMITLOAD)
 (put '*STORE   'emitfn '&EMITSTORE)
 (put '*JUMP    'emitfn '&EMITJUMP)
 (put '*LBL     'emitfn '&EMITLBL)
%(put '*ADDMEM  'emitfn '&EMITMEMMOD)
%(put '*MPYMEM  'emitfn '&EMITMEMMOD)
 (put '*USES    'emitfn '&USES)                                    %       scs
 (put '*RETURN  'emitfn '&RETURN)                                  %       scs
 
 % Optimizing functions
 
 (put '*LBL        'optfn          '&LBLOPT)
%(put '*MOVE       'optfn          '&STOPT) no move / push optimization
 (put '*JUMP       'optfn          '&JUMPOPT)
 
 % Assorted other flags
 
 (flag '(*JUMP *LINKE *EXIT)                'TRANSFER)
 (flag '(*LINK *LINKE)                      'UNKNOWNUSE)
 
 (put '*LINK  'EXITING     '*LINKE)
 
 % Initialize variables
 
 (setq *MSG                T)                        % Do print messages
 (setq *INSTALLDESTROY     NIL)
 (setq *USINGDESTROY       T)
 (setq *SHOWDEST           NIL)
 (setq *NOFRAMEFLUID       T)
 (setq *USEREGFLUID        NIL)
 (setq *NOLINKE            NIL)       %. Permit LINKE
 (setq *ORD                NIL)       %. Dont force ORDER
 (setq *R2I                T)         %. Do convert Rec to Iter
 (setq GLOBALGENSYM&       (LIST (GENSYM)))       % initialize symbol list
 
 (setq MAXNARGS&         15)
 (setq LASTACTUALREG&     5)
