%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CRAY-COMP.SL - Compiler Patterns for CRAY PSL ,plus a few CMacro expanders
%
% Author:      M. L. Griss
%              Computer Science Dept.
%              University of Utah
% Date:        1 June 1982
% Based on M68k-COMP.RED of 1 June 1982
%
% Copyright (c) 1982 Griss for the CRAY version
% Copyright (c) 1987 Konrad Zuse Zentrum Berlin for modifications
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revised for PSL 3.4 (CRAY) by H. Melenk and W. Neun , ZIB Berlin
%    Januar 1987
%    added some new pattern( conspat etc)
%    April 1986
%    December 1986 changed Tvpat and Tvpat1 to avoid some Jumps
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(put 'Tvpat 'Pattern '(
    &regmem ('*Destroy Dest)
    ((Dest UsesDest) (Mac l1 a1 a2) ('*Load Dest '(Quote NIL))
            ('*Jump l2) ('*Lbl l1) ('*Load Dest '(Quote T)) ('*Lbl l2))
    ((UsesDest UsesDest) (Mac l1 a1 a2) ('*Load Dest '(Quote NIL))
            ('*Jump l2) ('*Lbl l1) ('*Load Dest '(Quote T)) ('*Lbl l2))
    ((UsesDest Dest) (Mac l1 a1 a2) ('*Load Dest '(Quote NIL))
            ('*Jump l2) ('*Lbl l1) ('*Load Dest '(Quote T)) ('*Lbl l2))
    ((Dest any) ('*Load t1 a1) ('*Load Dest '(Quote T))
                (Mac l2 t1 a2) ('*Load Dest '(Quote NIL))
                ('*Lbl L2))
    ((any Dest) ('*Load t1 a2) ('*Load Dest '(Quote T))
                (Mac l2 a1 t1) ('*Load Dest '(Quote NIL))
                ('*Lbl l2))
    ((UsesDest any) ('*Load t1 a1) ('*Load Dest '(Quote T))
                    (Mac l2 t1 a2) ('*Load Dest '(Quote NIL))
                    ('*Lbl l2))
    ((any UsesDest) ('*Load t1 a2) ('*Load Dest '(Quote T))
                    (Mac l2 a1 t1) ('*Load Dest '(Quote NIL))
                    ('*Lbl l2))
    (any ('*Load Dest '(Quote T)) (Mac l1 a1 a2)
         ('*Load Dest '(Quote NIL)) ('*Lbl l1))))
 
 
(put 'Tvpat1 'Pattern
   '(&REGMEM ('*Destroy Dest)
    ((Dest) ('*Load t1 a1) ('*Load Dest '(Quote T))
            (Mac l2 t1 p2) ('*Load Dest '(Quote NIL))
            ('*Lbl l2))
    ((UsesDest) ('*Load t1 a1) ('*Load Dest '(Quote T))
                (Mac l2 t1 p2) ('*Load Dest '(Quote NIL))
                ('*Lbl l2))
    (any ('*Load Dest '(Quote T)) (Mac l1 a1 p2)
         ('*Load Dest '(Quote NIL)) ('*Lbl l1))))
 
(put 'Tstpat 'Pattern
  '(NIL
    &Fixregtest
    ((Regn any) (Mac Dest a1 a2))
    (any (Mac Dest a2 a1))))
 
(put 'TstpatC 'Pattern
    '(nil &SetRegs1
     ((Regn any) (Mac Dest a1 a2))
     (any (p2 Dest a2 a1))))
 
(put 'Tstpat2 'Pattern
    '(NIL &SetRegs1
     (any (Mac Dest a1 p2))))
 
(put 'SetqPat 'Pattern
 '(NIL NIL
 ((Noval Reg memory) ('*Store a2 a1))% memory load into register
 ((Noval any memory) ('*Load T1 a2) ('*Store T1 a1))% memory load
 ((Noval any notanyreg) ('*Store a2 a1))
 ((Noval Dest any) ('*Store a2 Dest))
 ((Noval UsesDest any) ('*Load T1 a2) ('*Store T1 a1))
%((Noval any any) ('*Load Dest a2) ('*Store Dest a1))
 ((Noval any any) ('*Load T1 a2) ('*Store T1 a1))% schwer,schwer
%((Noval any any) ('*Store a2 a1))
 ((any Dest) ('*Store Dest a1))
 ((Dest any) ('*Store a2 Dest))
 ((UsesDest any) ('*Store a2 a1) ('*Store a2 Dest))
 (any ('*Load Dest a2) ('*Store Dest a1))))
 
(put 'Rplacpat 'Pattern
   '(NIL NIL
   ((Noval any any) ('*Store a2 (Mac a1)))
   ((Dest any) ('*Store a2 (Mac a1)))
   ((UsesDest any) ('*Store a2 (Mac a1)) ('*Load Dest a1))
   ((any Dest) ('*Store a2 (Mac a1)) ('*Load Dest a1))
   ((any UsesDest) ('*Store a2 (Mac a1)) ('*Load Dest a1))
   (any ('*Load Dest a1) ('*Store a2 (Mac Dest)))))
 
(put 'Assocpat 'Pattern
  '(NIL  ('*Set Dest (fn a1 a2))
  ((Dest any) (Mac a1 a2))
  ((any Dest) (Mac a2 a1))
  ((UsesDest UsesDest) ('*Load t1 a1) ('*Load Dest a2) (Mac Dest t1))
  ((any UsesDest) ('*Load Dest a2) (Mac Dest a1))
  (any ('*Load Dest a1) (Mac Dest a2))))
 
(put 'Subpat 'Pattern
   '(NIL ('*Set Dest (FN a1 a2))
   ((Dest any) (Mac a1 a2))
%% ((any Dest) ('*Wminus Dest Dest) ('*Wplus2 a2 a1))
   ((any Dest) ('*Wdifference3 Dest a1 Dest))
   ((any UsesDest) ('*Load t1 a2) ('*Load Dest a1) (Mac Dest t1))
   (any ('*Load Dest a1) (Mac Dest a2))))
 
(put 'Nonassocpat 'Pattern
   '(NIL ('*Set Dest (FN a1 a2))
   ((Dest any) (Mac a1 a2))
   ((any UsesDest) ('*Load T1 a2) ('*Load Dest a1) (Mac Dest T1))
   (any ('*Load Dest a1) (Mac Dest a2))))
 
(put 'fieldpat 'Pattern
  '(NIL ('*Set Dest (FN a1 a2 A3))
   (any (Mac Dest a1 a2 A3))))
 
(put 'putfieldpat 'Pattern
  '(NIL NIL
   ((Noval any any any any) (Mac a1 a2 A3 A4))
    (any (Mac a1 a2 A3 A4) ('*Store a1 Dest))))
 
(put 'unarypat 'Pattern
   '(&noanyreg ('*Set Dest (FN a1))
    (any (Mac Dest a1))))
 
%(put 'modmempat 'Pattern
%   '(NIL NIL
%    (any (Mac a1 a2))))
 
%(put 'modmempat1 'Pattern
%  '(NIL NIL
%   (any (Mac a1))))
 
(put 'CarCdrPat 'Pattern '(nil nil (any ('*return (fn a1)))))
 
(put 'aplus2pat 'Pattern '(nil nil (any ('*return (Mac a1 a2)))))
 
(put 'atimes2pat 'Pattern '(nil nil (any ('*return (Mac a1 a2)))))
 
(put 'MemoryPat 'Pattern '(nil nil
            ((any const) ('*return (fn a1 a2)))
            (any         ('*return (fn ('$aplus2 a1 a2) ('wconst '0))))
))
 
(put 'conspat 'pattern
  '(nil ('*Destroy Dest)
   ((Dest any)     (mac a1 a2))
   ((any Dest)     ('*xcons a2 a1))
   ((any usesDest) ('*load t1 a2) ('*load Dest a1) (mac Dest t1))
   (any            ('*load Dest a1) (mac Dest a2))))
 
(put 'fastmkfltnpat 'pattern
  '(nil ('*Destroy dest)
   (dest    (mac a1))
   (any     ('*load dest a1) (mac dest))))
 
(put 'Reclaimpat 'pattern
  '(nil nil
   (any    (mac))))
