%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:           PC: COMMON-PREDICATES.SL
% Title:          Predicates used for Anyreg and C-macro expansion
% Author:         Eric Benson
% Created:        21 December 1981
% Modified:       11-Sep-84 08:24:54 (Brian Beach)
% Status:         Experimental
% Mode:           Lisp
% Package:        
% Compile to:     none
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1981, University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 06-Dec-83 10:00 (Brian Beach)
%   New header.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
 
(fluid '(EntryPoints!*
       !*FastLinks))
 
(global '(!*R2I))
 
(de RegisterP (Expression)
  (EqCar Expression 'REG))
 
(de AnyP (Expression)
  T)
 
(de TaggedLabel (X)
  (EqCar X 'Label))
 
(de EqTP (Expression)
  (equal Expression T))
 
(de MinusOneP (Expression)
  (equal Expression -1))
 
(de InternallyCallableP (X)            % only when writing a file
  (and (or !*WritingFaslFile (not (FUnBoundP 'AsmOut)))
       (or !*FastLinks
         (and !*R2I (memq X EntryPoints!*))
         (FlagP X 'InternalFunction)
         (FlagP X 'FastLink))))
 
(de AddressConstantP (Expression)
  (or (atom Expression) (equal (car Expression) 'Immediate)))
 
