%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PNK:IO-ERRORS.SL
% Title:        Error handlers for input and output
% Author:       Eric Benson
% Created:      27 August 1981
% Modified:     22-Mar-84 11:31:26 (Brian Beach)
% Status:       Experimental
% Mode:         Lisp
% Package:      Kernel
% Compiletime:
% Runtime:
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1981, University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
%
% Revisions:
%
% 01-Dec-83 14:48:09 (Brian Beach)
%   Translated from Rlisp to Lisp.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(de channelnotopen (chn ch)
  (channelerror chn "Channel not open"))
 
(de writeonlychannel (chn)
  (channelerror chn "Channel open for write only"))
 
(de readonlychannel (chn ch)
  (channelerror chn "Channel open for read only"))
 
(de illegalstandardchannelclose (chn)
  (channelerror chn "Illegal to close standard channel"))
 
(de ioerror (message) % is used by terminalinputhandler with non str
  (stderror (bldmsg "I/O Error: %w" message)))
 
(de channelerror (channel message)
  (stderror (bldmsg "I/O Error on channel %d: %s" (intinf channel) message)))
 
 
