%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PNK:OTHERS-SL.SL
% Title:        Random Standard Lisp functions
% Author:       Eric Benson
% Created:      20 August 1981
% Modified:     22-Mar-84 11:41:47 (Brian Beach)
% Status:       Experimental
% Mode:         Lisp
% Package:      Kernel
% Compiletime:
% Runtime:
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1981, University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 01-Dec-87 W. Neun , ZIB Berlin
%   Separated CRAY-1 dependent code (DRI/ERI)
% 01-Sep-87 W. Neun , ZIB Berlin
%   Cray specific versions for liter digit and length
%   Done various optimization for CRAY version
% 01-Dec-83 14:56:54 (Brian Beach)
%   Translated from Rlisp to Lisp.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% These are functions that didn't have a logical home
% Most could have been defined portably, but were not for efficiency reasons
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
(off r2i)
 
(de fixp (u)
  % Is U an integer?
  (fixp u))
 
(on r2i) 
 
%(de digit (u)
  % Is U an ID whose print name is a digit?
% (and (idp u) (wgeq (setq u (idinf u)) (char !0)) (wleq u (char !9))))
 
%(de liter (u)
%  (and % Is U a single character alphabetic ID?
 
%       (idp u)
%       (or (and (wgeq (setq u (idinf u)) (char a)) (wleq u (char z)))
%           (and (wgeq u (char !a)) (wleq u (char !z))))))
 
(compiletime
 (progn
  (load if-system)
  (flag '(length1) 'internalfunction)
))
 
%(de length (u)
%  % Length of list U
%  (length1 u 0))
 
%(de length1 (u n)
%  (if (pairp u)
%    (length1 (cdr u) (iadd1 n))
%    n)) 
 
(de digit (u)  (eq 1 (wrshift
                      (wand (wdifference 8#057 (inf u))%(char 0) -1
                            (wdifference (inf u) 8#072)) % char 9 +1
                                 63)))
 
(de liter (u)
  (prog (&infu&)
    (setq &infu& (inf u))
    (return
     (eq 0 (wor (wxor (tag u) id-tag)
               (wrshift
                  (wand (wor (wdifference &infu& 8#141) % a
                             (wdifference 8#172 &infu&)) % z
                        (wor (wdifference &infu& 8#101) % A
                             (wdifference 8#132 &infu&)) % Z
                   ) 63))))))
(if_system CRAY1
   (progn
      (de length (u)
       %  % Length of list U
       (length1 u 0))
 
      (de length1 (u n)
        (if (pairp u)  (length1 (cdr u) (iadd1 n))  n))))
 
(compiletime (off lapopt))
 
(if_system Cray1 NIL
 (lap '((*entry length expr 1)
           (DRI)
           (*move 0 (reg 3))
           (*move (reg 1) (reg s6))
           (*move 1 (reg 4))
           (*move pair-tag (reg s7))
           (*lbl (label (labelgen templabel)))
           (*move (reg s6) (reg 1))
           (*move (reg s6) (reg a6))
           (*move (indexed (reg a6) 1) (reg s6))
           (*wrshift (reg 1) 59)
           (*move (reg 3) (reg 2))    %update count
           (*wxor3 (reg s0) (reg 1) (reg s7))
           (*wplus2 (reg 3) (reg 4))  % increment
           (*jumpeq (labelref templabel) (reg s0) 0)
           (*move (reg 2) (reg 1))    % value
           (*move (reg s6) (reg s7))  % synch for preload
           (ERI)
           (j (reg b00))
)     )) 
 
(compiletime (on lapopt))
 
