%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:              UNICOS-EXTENSIONS
% Description:       Extended UNICOS-Interface for PSL3.4
% Author:            W. Neun , ZIB Berlin
% Created:           28-May-87
% Mode:              Lisp
% Package:           NonKernel(Cray UNICOS)
% Status:            Experimental (Do Not Distribute)
%
% (c) Copyright 1987, Konrad Zuse-Zentrum Berlin, all rights reserved
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
(compiletime (load inum vector-instructions))
 
(compiletime (flag '(print-abort map-at1 whosdunnit
                     dump-v-register)               'internalfunction))
 
(fluid '(*libpath*))
 
(de clear-rest-of-word (strin)
    (prog (len len1)
         (setq len (add1 (strlen strin)))
         (setq len1 (plus (times 8 (quotient (plus len 8) 8)) -1) )
         (ifor (from i len len1 1)
               (do (putbyte (strbase (strinf strin)) i 0)
         )     )
         (return strin)
)   )
 
% Format : (set-libpath "path") a / is added in io routines
 
(de set-libpath (strin)
   (if (stringp strin)
            (cos-own (clear-rest-of-word (setq *libpath* strin)))
            (nonstringerror strin 'set-libpath)
) )
 
% Format : (system "shell command")
 
(de system (strin)
   (if (stringp strin)
    (cos-id    (clear-rest-of-word strin))
    (nonstringerror strin 'shellcmd)
) )
 
% LISP REPRIEVE processing. this routine is called from kernel (lisprpv)
% this function must be coded in LAP because it may not destroy Register
 
(Fluid '(undefnb00* *batch *cft-mode *dump *noreprieve *vregdump
        &numberofreprieves& ))
 
(setq   &numberofreprieves& 15)
 
(compiletime (setq *syslisp nil))
(compiletime (off lapopt))
 
(lap '((*entry lisp-reprieve expr 0)        % Lisp Reprieve-Routine
       (*move 5 (reg a3))                   %simulate an (alloc 3)
       (*Move (Reg B00) (Reg A6))           % save b00 and t00
       (*Move (Reg A6) (Reg 3))             % to print correct
       (*Move (Reg T00) (Reg 4))            % Register contents
       (*Move ($Fluid NIL) (Reg S6))        % restore nil
                                          % first rpv will be set
       (*Move (Reg S6) (Reg T00))         % by cosclrio
       (*Move ($Fluid *cft-mode) (Reg S6))
       (*Move (Reg S6) ($Fluid undefnb00*))   % saves an id
       (*jumpnoteq (label reload) (Reg S6) (quote nil))
     postreload
       (*jumpeq (label novregdump) ($fluid *vregdump) (quote nil))
       (*move 512 (reg a5))                % dumping vregs if requested
       (*move (reg Heaplast) (Reg a6))
       (*move (reg HeapTrapBound) (reg a7))
       (*wdifference (reg a7) (reg a5))
       (*jumpwgeq (label novregdump) (reg a6) (reg a7))
       (*move 64 (reg a5))
       (*move (reg a7) (reg s7))
       (*move (reg s7) ($fluid undefncode*))   % here   addr of dumparea
       (*vsetvl (reg a5))
       (*move (reg a7) (reg a0))
       (vstore (reg v0) (reg a0))
       (*wplus2 (reg a7) (reg a5))
       (*move (reg a7) (reg a0))
       (vstore (reg v1) (reg a0))
       (*wplus2 (reg a7) (reg a5))
       (*move (reg a7) (reg a0))
       (vstore (reg v2) (reg a0))
       (*wplus2 (reg a7) (reg a5))
       (*move (reg a7) (reg a0))
       (vstore (reg v3) (reg a0))
       (*wplus2 (reg a7) (reg a5))
       (*move (reg a7) (reg a0))
       (vstore (reg v4) (reg a0))
       (*wplus2 (reg a7) (reg a5))
       (*move (reg a7) (reg a0))
       (vstore (reg v5) (reg a0))
       (*wplus2 (reg a7) (reg a5))
       (*move (reg a7) (reg a0))
       (vstore (reg v6) (reg a0))
       (*wplus2 (reg a7) (reg a5))
       (*move (reg a7) (reg a0))
       (vstore (reg v7) (reg a0))
     novregdump
       (*jumpnoteq (label expect)
                  ($Fluid *expected-interrupt) (quote nil))
       (*move ($Fluid &numberofreprieves&) (reg s6))
       (*move 1 (reg s7))
       (*wdifference (reg s6) (reg s7))
       (*move (reg s6) ($Fluid &numberofreprieves&))
       (*move (reg s6) (reg s0))
       (jsp (label goon))
       (*move ($fluid *batch) (reg s6))
       (*move (quote nil) (reg s7))
       (*wxor3 (reg s0) (reg s6) (reg s7))
       (jsz (label goon))
       (*Move (quote "+++ Too many unexpected interrupts +++") (Reg 1))
       (*call console-print-string)
       (*Move (quote "+++ PSL aborts +++") (Reg 1))
       (*call console-print-string)
       (*call abort)
     goon
       (*Move -1 (Reg 1))        % tells no print at all
       (*jumpeq (label nodump) ($Fluid *emsgp) (quote nil))
       (*Move 0 (Reg 1))        % tells no dump, but a message
       (*jumpeq (label nodump) ($Fluid *dump) (quote nil))
       (*Move ($Fluid TRegSave) (Reg 1)) % tells to print a dump        O
       (*Move ($Fluid BRegSave) (Reg 2))
     nodump                                % set new rpv and eventually
       (*call dump-Registers expr 4)       % show Register-contents
       (*jumpnoteq (label norepr) ($Fluid *noreprieve) (quote nil))
       (*wand3 (Reg s6) (reg 1) 16#ffffff) %error address in loworder
       (*move (reg s6) (frame 1))
       (*wshift (Reg 1) -32)    % abcode is in the high-order bits
                                % after dump-Registers
       (*move (reg 1) (frame 2))
 
       (*jumpeq (label nemsg) ($Fluid *emsgp) (quote nil))
 
       (*jumpeq (label novregdump1) ($fluid *vregdump) (quote nil))
       (*move ($fluid undefncode*) (reg 1))   % here   addr of dumparea
       (*call dump-v-register)
     novregdump1
       (*move (frame 2) (reg 1))
       (*call print-abort)
       (*move (frame 1) (reg 1))
       (*call map-at)
       (*jumpnoteq (label cft) ($Fluid undefnb00*) (quote nil))
     try-to-continue
     nemsg
       (*move (frame 2) (reg 1))
       (*link user-error-function expr 1)
       (*move (frame 2) (reg 1))
%%%    (*jumpeq (label finale) (reg 1) 22) %either UNICOS 2.1 cpu excc or CRAY2
       (*jumpnoteq (label notimelimit) (reg 1) 26) %dont continue
%%%  finale   % no more UNICOS 2.1 machines
       (*call abort)
     notimelimit
       (*jumpeq (label nemsg2) ($Fluid *emsgp) (quote nil))
       (*Move (quote "*** PSL tries to continue ***") (Reg 1))
       (*call console-print-string)
     nemsg2
       (*Move (quote $error$) (Reg 1))
       (*Move (quote nil) (Reg 2))
       (*link throw expr 2)
     norepr
       (*Move (quote "*** Interrupt, full reprieve inhibited:") (Reg 1))
       (*call console-print-string)
       (*Move ($fluid *noreprieve) (Reg 1))
       (*call console-print-string)
       (*call abort)
     reload
       (*Move  ($Fluid BRegSave) (Reg A0))
       (*Move  64 (Reg A1))
       (BlkLod (Reg A1) (Reg B00))
       (*Move  ($Fluid TRegSave) (Reg A0))
       (BlkLod (Reg A1) (Reg T00))
       (*Move ($Fluid A3SAVE) (Reg A3))
       (*Move ($Fluid A4SAVE) (Reg A4))
       (*jump (label postreload))
     cft 
       (*Move (Reg T00) ($Fluid *cft-mode))     % *cft-mode = nil
       (*jumpeq (label try-to-continue) ($Fluid *batch) (quote nil))
       (*Move (quote "Interrupt in CFT-Code, no recovery when in batch")
            (Reg 1))
       (*call console-print-string)
       (*call abort)
     expect                         % some COS-functions will abort
       (*Move (Reg T00) ($Fluid *cft-mode))     % *cft-mode = nil
       (*Move (Reg T00) ($Fluid *expected-interrupt))
       (*Move -1 (Reg 1))                   % tells no printed dump
       (*link dump-Registers expr 5)        % set new reprieve
       (*jumpeq (label noemsg) ($Fluid *emsgp) (quote nil))
       (*Move (quote "*** An expected Interrupt has occured") (Reg 1))
       (*call console-print-string)
     noemsg
       (*Move (quote $error$) (Reg 1))
       (*Move (quote nil) (Reg 2))
       (*link throw expr 2)
)     )
(compiletime (on lapopt))
(compiletime (setq *syslisp T))
 
% user exit after reprieve-processing
% may be redefined
 
(de user-error-function (x) nil)
 
% print abort-codes  saves nextbps and options* and optionaddresses*
 
(Fluid '(options* nextbps *in-abort-print optionaddresses*
         cos-version*))
 
(setq cos-version* 30)   %default 3.0 UNICOS
 
(de print-abort (num)
    (prin2 "*** SIGNAL ")
    (prin2 num)
    (prin2 " invoked: ")
    (prin2t (if (setq num (assoc num
           '( (1 . "Hangup")
              (2 . "Interrupt")
              (3 . "Quit")
              (4 . "Illegal instruction")
              (5 . "Trace trap")
              (6 . "Hardware Error")
              (7 . "Error exit")
              (8 . "Floating point exception")
              (9 . "Kill")
             (10 . "Program range error")
             (11 . "Operand range error")
             (12 . "Bad Argument to system call")
             (13 . "Write on a pipe with no one to read it")
             (14 . "Alarm clock")
             (15 . "Software termination signal")
             (16 . "User defined signal 1")
             (17 . "User defined signal 2")
             (18 . "Death of a child")
             (19 . "Power failure restart")
  % 20 - 22 for Cray - 2  now , UNICOS 2.1 formerly used them
  %          (20 . "Uncorrectable memory error UNICOS 2.1")
  %          (21 . "True deadlock UNICOS 2.1")
  %          (22 . "cpu limit exceeded UNICOS 2.1")
             (20 . "Cray-2 multi-tasking wakeup signal")
             (21 . "Cray-2 multi-tasking kill signal")
             (22 . "Cray-2 FORTRAN async I/O completion")
             (23 . "recovery signal")
             (24 . "Unrecoverable memory error")
             (25 . "True deadlock detected")
             (26 . "CPU time limit exceeded")
             (27 . "imminent system shutdown"))))
  % 28 - 32 reserved for Cray Research Inc.
         (cdr num) "unknown signal")))
 
(de map-at(x)
     (if heaptrapped (console-print-string
                        "+++ Error during Garbage Collection")
         (progn (prin2l (map-at1 x)) (terpri))))
 
(de map-at1 (x)    %looking for function causing the error
     (prog (min max minfkt maxfkt xx)
          (setq max nextbps)
          (setq min 0)
          (when (wgreaterp x nextbps)(return "*** outside code area"))
          (when (and (wgreaterp x symfnc)
                     (wlessp x (wplus2 symfnc maxsymbols)))
              (setq xx (wlshift (symfnc (wdifference x symfnc)) 2))
              (return (append  (whosdunnit xx optionaddresses*)
                      (list2
                      "; while entering" (mkid (wdifference x symfnc))))
          )   )
          (ifor (from y 0 maxsymbols 1)
              (do (cond ((funboundp (mkid y)) nil)   % those aren't of
                        ((flambdalinkp (mkid y)) nil) % any interest
                        ((not (stringp (symnam y))) nil) % unused id
                        ((and (wlessp (symfnc y) max)
                              (wgeq   (symfnc y) x  ))
                                 (setq max (symfnc y))
                                 (setq maxfkt (mkid y)))
                         ((and (wgeq   (symfnc y) min)
                               (wleq   (symfnc y) x  ))
                                 (setq min (symfnc y))
                                 (setq minfkt (mkid y)))
           )   )  )
    (return (append  (whosdunnit x optionaddresses*)
                     (list4 "; next external entries are" minfkt
                         "and" maxfkt))
)   ) )
 
(de whosdunnit (x optlist)
   (cond 
     ((null optlist) '("*** within code directly compiled to BPS"))
     ((and (wgreaterp x (cadar optlist))
              (wleq x (cddar optlist)))
                    (list2 "*** in load module " (caar optlist)))
     (t    (whosdunnit x (cdr optlist)))
) )
 
(de dump-v-register (addr)
  (prog (a b c)
   (console-newline)
   (console-print-string "*** Dump der Vector Register ***")
   (console-newline)
   (ifor (from vreg 0 7 1)
          (do (progn (terpri)
                (prin2 "Vectorregister ") (prin2t vreg)
                (ifor (from vregelt 0 62 3)
                       (do (progn
                            (setq a (getmem addr))
                            (setq b (getmem (wplus2 addr 1)))
                            (setq c (getmem (wplus2 addr 2)))
                            (setq addr (wplus2 addr 3))
                            (when (wlessp vregelt 10)
                             (terminalwritechar 32 32))
                            (putint vregelt)
                            (terminalwritechar 32 32)
                            (putoct a)
                            (terminalwritechar 32 32)
                            (putoct b)
                            (terminalwritechar 32 32)
                            (putoct c) (console-newline)
                )      )    )
                (setq a (getmem addr))
                (setq addr (wplus2 addr 1))
                (putint 63)
                (terminalwritechar 32 32)
                (putoct a)
                (console-newline)
 
   )      )    )
   (console-newline)
) )

(fluid '(unixargs*))

(de getunixargs ()
   (setq unixargs* (vector 'NIL)))
   
