%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PNK:BACKTRACE.SL 
% Title:        Functions for displaying the return stack. 
% Author:       ??? 
% Created:      ??? 
% Modified:     22-Mar-84 09:23:19 (Brian Beach) 
% Package:      Kernel 
%
% (c) Copyright 1987, University of Utah, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(on fast-integers)

(compiletime
  (flag '(backtrace1 backtracerange backtracerange1 
	  verbosebacktrace1 backtracerange11)  'internalfunction)

  (put  'get-stack-hack 'opencode '((*move (reg st) (reg 1))))) 

(fluid '(ignoredinbacktrace* options* interpreterfunctions*))
(fluid '(in* out* *dump))

(setq ignoredinbacktrace*
      (list 'eval 'apply 'fastapply 'codeapply 'codeevalapply 'catch
	    'errorset 'evprogn 'toploop 'breakeval 'bindeval 'break 'main
	    'TOP-LOOP-EVAL-AND-PRINT 'PRE-MAIN))
%%%%%%       'stackcheck))

(setq interpreterfunctions* (list 'cond 'prog 'and 'or 'progn 'setq))

(global '(heapupperbound stacklowerbound))

(de interpbacktrace ()
  (prog (here)
	(setq here (get-stack-hack))
	(printf 
	   "Backtrace, including interpreter functions, from top of stack:%n")
	(return (backtracerange here stacklowerbound 1 nil nil))))

(de backtrace ()
  (prog (here x)
	(setq here (get-stack-hack))
	(printf "Backtrace from top of stack:%n")
	(return (backtracerange here stacklowerbound 0 nil nil))))

(de backtracerange (starting ending interpflag)
   (prog (stackptr stackold frameptr memo)
        (setq stackptr starting)
        (setq stackptr (wgetv stackptr 1))
        (setq stackptr (wgetv stackptr 1))
	(setq stackold (wgetv stackptr 1))

        (while (wlessp stackptr stacklowerbound)
                (progn
                 (backtrace1 (mkitem id-tag (wgetv stackptr 16)) interpflag)
		 (setq frameptr (wplus2 stackptr 80))
    	         (for (from i frameptr stackold 4)
		  (do (setq memo (getmem i))
		      (when (eq (tag memo) btr-tag)
			(backtrace1 (mkitem id-tag (inf memo)) interpflag))))
                 (setq stackptr stackold)
		 (setq stackold (wgetv stackptr 1))))
         (return nil)))

(de verbosebacktrace ()
    (unless (member 'addr2id options*)  (load addr2id))
    (backtracerange 0 0 0 0 T))

(de verbosebacktrace1 (x y) % for one item 
     (cond ((and (codep x) (wgreaterp (inf x) heapupperbound))
	                 (writechar (char tab))
	                 (channelwriteunknownitem out* x)
	                 (terpri))
	   ((weq (tag x) btr-tag)  (printf "       %r%n" (mkid (inf x))))
	   ((setq y (returnaddressp x))
	            (printf "%p -> %p:%n"
	               (code-address-to-symbol (inf x)) y))
           ((and (idp x) (wgreaterp (inf x) maxsymbols)) NIL)
				% always problems with stackaddresses!
	   (t (printf "     %p%n" x))))

(de backtrace1 (item code)
  %
  % Code is 1 if Interpreter functions should be printed, 0 if not.
  %
 (when (and (wlessp (inf item) maxsymbols) (stringp (symnam (inf item))))
  (unless (memq item ignoredinbacktrace*)
    (unless (and (equal code 0) (memq item interpreterfunctions*))
      (prin1 item)
      (writechar (char blank))))))

(off fast-integers)
