%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PNK:IO-EXTENSIONS.SL 
% Title:        Random, possibly useful functions 
% Author:       Eric Benson 
% Created:      22 October 1981 
% Modified:     22-Mar-84 11:31:57 (Brian Beach) 
% Package:      Kernel 
%
% (c) Copyright 1987, University of Utah, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 27-May-87 (Harold Carr & Leigh Stoller)
%  Changed declaration of in* and out* from global to fluid.
% 26 Jan 1984 1000-PST (Brian Beach)
%  Corrected file name in header.
% 01-Dec-83 14:48:33 (Brian Beach)
%   Translated from Rlisp to Lisp.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(fluid '(in* out*))

(de channeltyi (chn)
  %. Read one char ASCII value
  (mkint (channelreadchar chn)))

(de channeltyo (chn ch)
  %. Write one char ASCII value
  (channelwritechar chn (lisp2char ch)))

(de tyi ()
  %. Read ASCII value from curent input
  (channeltyi in*))

(de tyo (ch)
  %. Write ASCII value to current output
  (channeltyo out* ch))

% End of file.
